#!/bin/sh
set -x
# Version: 0.0.5 pre-alpha
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id: vdr2dvd.sh,v 1.2 2003/06/28 14:33:06 dimi Exp $

. ./vdrconvert.env

# Default werte
[ -z "$DVD_DESTDIR" ]  && DVD_DESTDIR=$DESTDIR/dvd
# Writertype : 0 = DVD+RW/+R , 1 = DVD-RW/-R
[ -z "$WRITERTYPE" ]          && WRITERTYPE=1
# Options for tcmplex
[ -z "$DVDTCMPLEXOPTS" ]      && DVDTCMPLEXOPTS="-m d"
# No transcode for this values
[ -z "$DVDALLOWEDWIDTH" ]     && DVDALLOWEDWIDTH="720 704 352 480"
# more options
[ -z "$DVDTRANSCODEOPTS" ]    && DVDTRANSCODEOPTS="-I 3 -V -y mpeg -Z 720x576 -b 192"
[ -z "$DVDTRANSCODEBITRATE" ] && DVDTRANSCODEBITRATE="5000000.0"
# Devices
[ -z "$DVDPLUS_DEVICE" ]      && DVDPLUS_DEVICE="/dev/scd1"
# For eject
[ -z "$DVDPLUSD_DEVICE" ]     && DVDPLUSD_DEVICE=$DVDPLUS_DEVICE
[ -z "$DVDMINUS_DEVICE" ]     && DVDMINUS_DEVICE="0,0,0"
[ -z "$DVDAUTOWRITE" ]        && export DVDAUTOWRITE=no
# For eject
[ -z "$DVDMINUSD_DEVICE" ]    && DVDMINUSD_DEVICE="/dev/scd0"
[ -z "$DVDPLUS_RECORDCMD" ]   && DVDPLUS_RECORDCMD="sudo growisofs"
[ -z "$DVDMINUS_RECORDCMD" ]  && DVDMINUS_RECORDCMD="sudo dvdrecord"
[ -z "$DVDMINUS_BLANKOPTS" ]  && DVDMINUS_BLANKOPTS="speed=1 driveropts=burnfree -dao blank=fast"
[ -z "$DVDPLUS_OPTS" ]        && DVDPLUS_OPTS=-Z
[ -z "$DVDMINUS_OPTS" ]       && DVDMINUS_OPTS="-eject speed=1 driveropts=burnfree -dao"
[ -z "$DVDCLEAN" ]	      && DVDCLEAN="no"
[ -z "$DVDAUTHORMODE" ]       && DVDAUTHOROPTS=marks
DVDAUTHORCHAPTERS="0,15:00,30:00,45:00,1:00:00,1:15:00,1:30:00,1:45:00,2:00:00,2:15:00,2:30:00,2:45:00"
[ -z "$DVDAUTHORUSERCHAP" ]    && DVDAUTHORUSERCHAP=$DVDAUTHORCHAPTERS


NewJobs=$1
JOBFIL=$2
DESTDIR=$DVD_DESTDIR
TEMPDIR=${TEMPDIR}/${JOBFIL}

[ -d $DESTDIR ] || mkdir -p $DESTDIR 
[ -d $TEMPDIR ] || mkdir -p $TEMPDIR

if [ -w ${TEMPDIR} -a -w ${DESTDIR} ]
then
      declare CMDLIN=`head -n1 $NewJobs`   # Job auslesen
      rm $NewJobs
      let Number=1
      UniqueDVDDIR=`mktemp -d ${TEMPDIR}/VDR2DVD.XXXXXX` 
      mkdir -p ${UniqueDVDDIR}
      Image=`mktemp ${DESTDIR}/DVDImage.XXXXXX`
      nice -${PRIO} dvddirgen -o ${UniqueDVDDIR}
      # Create table of contents file
      echo "Inhaltsverzeichniss fr ${Image}" > ${Image}.txt
      echo "" >> ${Image}.txt
      for i in $CMDLIN
      do
	  UniqueDir[Number]=`mktemp -d ${TEMPDIR}/VDRSYNC.XXXXXX`
	  spalten=`echo $i|sed 's/\// /g'|wc -w`
	  Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	  let spalten=spalten-1
	  SubTitel=`echo $i|cut -f $spalten -d '/'`
	  Datum=`basename $i|cut -f1 -d'.'`
	  if [ "/$SubTitel" = "$VDRROOT" ] 
	  then
		Titel=${Datum}_${Record} 
	  else
		Titel=${SubTitel}/${Datum}_${Record}
		[ ! -d ${UniqueDir[Number]}/${SubTitel} ] && mkdir -p ${UniqueDir[Number]}/${SubTitel}
#		[ ! -d ${DESTDIR}/${SubTitel} ] && mkdir -p ${DESTDIR}/${SubTitel}

	  fi
	  mkdir -p ${UniqueDir[Number]}
	  cd ${UniqueDir[Number]}
          echo -o ${UniqueDir[Number]} $i/ | xargs nice -$PRIO $VDRSYNC 			  # und encoding starten ...      
	  if [ -f ${UniqueDir[Number]}/bd.ac3 ] 
	  then 
	    nice -${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/c0.mpa -s ${UniqueDir[Number]}/bd.ac3 -m d -o ${UniqueDir[Number]}/${Titel}.mpg 
	  else
	    nice -${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/c0.mpa -m d -o ${UniqueDir[Number]}/${Titel}.mpg
	  fi

	  printf "%02d %s\n" ${Number} ${Titel} >> ${Image}.txt

	  ASPOPT="4:3"
	  ASPECT=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $5}'`
	  if [ "$ASPECT" = "3" ];then
		 ASPOPT="16:9"
	  fi

	  case $DVDAUTHORMODE in
		  "15min")
      			  nice -${PRIO} $DVDAUTHOR -v pal,$ASPOPT,720xfull -a ac3+de,mp2+de -o ${UniqueDVDDIR} -c $DVDAUTHORCHAPTERS  ${UniqueDir[Number]}/${Titel}.mpg
			  ;;
		  "marks")
			  if [ -r $i/marks.vdr ]
			  then
		    	  printf "%s," 0 > ${UniqueDir[Number]}/chapters.vdr
		    	  marklines=`cat $i/marks.vdr|wc -l`
		    	  let marklines=marklines-1
		    
		    	  for t in `cat $i/marks.vdr|head -$marklines|cut -f1 -d'.'`
		    	  do
		        	  printf "%s," $t >> ${UniqueDir[Number]}/chapters.vdr
		    	  done
		    	  for t in `cat $i/marks.vdr|tail -1|cut -f1 -d'.'`
		    	  do
		        	  printf "%s\n" $t >> ${UniqueDir[Number]}/chapters.vdr
		    	  done
      		    	  nice -${PRIO} $DVDAUTHOR -v pal,$ASPOPT,720xfull -a ac3+de,mp2+de -o ${UniqueDVDDIR} -c `cat ${UniqueDir[Number]}/chapters.vdr` ${UniqueDir[Number]}/${Titel}.mpg
			  else
      		    	  nice -${PRIO} $DVDAUTHOR -v pal,$ASPOPT,720xfull -a ac3+de,mp2+de -o ${UniqueDVDDIR} -c $DVDAUTHORCHAPTERS ${UniqueDir[Number]}/${Titel}.mpg
			  fi
			  ;;
		  "user")
      			  nice -${PRIO} $DVDAUTHOR -o ${UniqueDVDDIR} -c $DVDAUTHORUSERCHAP ${UniqueDir[Number]}/${Titel}.mpg
			  ;;
		  *)
			  echo "unbekannter Author Modus $DVDAUTHORMODE. Keine Verarbeitung"
			  ;;
	  esac

	  # Check if transcode in needing
	  if [ "$TRANSCODE" != "no" ]
	  then
	    for vob in ${UniqueDVDDIR}/VIDEO_TS/*.VOB
	    do
		res=`transcode -c 1,1 -i $vob|grep "import frame"| awk '{print($6)}'|cut -f1 -d'x'`
		echo "Resolution $vob = $res"
		need_transcode=1
		for width in $DVDALLOWEDWIDTH
		do
			[ "$res" = "$width" ] && need_transcode=0
		done
		if [ $need_transcode -ne 0 ]
		then
			mv $vob $vob.trans
			dvd_prof=`mktemp ${UniqueDVDDIR}/dvd.prof.XXXXXX`
			echo "max_bitrate=$DVDTRANSCODEBITRATE" > $dvd_prof
			echo "-i $vob.trans $DVDTRANSCODEOPTS -F d,,${dvd_prof} -o $vob"|xargs nice -$PRIO $TRANSCODE
			echo "-o $vob -i $vob.m2v -p $vob.mpa $DVDTCMPLEXOPTS"|xargs nice -$PRIO $TCMPLEX
			rm -f $dvd_prof $vob.mpa $vob.m2v $vob.trans
		fi

	    done
	  fi
	  cd -
          rm -rf ${UniqueDir[Number]}
	  let Number=Number+1
      done

      nice -${PRIO} $DVDAUTHOR -T -o ${UniqueDVDDIR}
      nice -${PRIO} $MKISOFS -dvd-video -o ${Image} ${UniqueDVDDIR}

      $SVDRPSEND MESG "${Image} is ready to Burn"
      # Burn the result
# Automatismus ber resource Type=File einbauen und per OSD
      case $WRITERTYPE in
	0)
	    echo "Burn ${Image} whith $DVDPLUS_RECORDCMD $DVDPLUS_OPTS $DVDPLUS_DEVICE=${Image}"
      	    # sudo $DVDPLUS_RECORDCMD $DVDPLUS_OPTS $DVDPLUS_DEVICE=${Image}
	    #
	    # Remote Format with ssh (Hoffentlich ist keine wichtige DVD+RW drin ;-) : Nur kontroliert aktivieren )
            #echo "sudo /usr/local/bin/dvd+rw-format -f $DVDPLUS_DEVICE"|xargs ssh pelion
	    #sleep 3
            #echo "sudo /usr/local/bin/dvd+rw-booktype -dvd-rom-spec -media $DVDPLUS_DEVICE"|xargs ssh pelion
	    #sleep 2
	    # Remote Burn ( eine formatierte DVD+RW oder eine leere DVD+R sollte im Laufwerk liegen
	    #echo "sudo $DVDPLUS_RECORDCMD $DVDPLUS_OPTS $DVDPLUS_DEVICE=${Image}"|xargs ssh pelion

	    # Local Burn
	    sudo $DVDPLUS_RECORDCMD $DVD_OPTS $DVD_DEVICE=${Image}
	    status=$?
	    [ $status -eq 0 ] && rm ${Image} || echo "Error Burning ${Image}"
	    ;;
	1)
	    if [ "$DVDAUTOWRITE" = "yes" ]
	    then
	        until [ `ps -aef|grep $DVDMINUS_RECORDCMD|grep -v $DVDMINUS_RECORDCMD|wc -l` -eq 0 ]
	        do
		    sleep 60
	        done

	        let status=1
	        until [ $status -eq 0 ] 
	        do
    	            eject $DVDMINUSD_DEVICE
		    tail -1 ${Image}.txt|xargs $SVDRPSEND MESG
		    if [ "$DVDCLEAN" = "yes" ]
		    then
    	                $SVDRPSEND MESG "Please insert a DVD into the Writer for Cleaning"
		        sleep 20
			$DVDMINUS_RECORDCMD dev=$DVDMINUS_DEVICE $DVDMINUS_BLANKOPTS
		    fi
    	            $SVDRPSEND MESG "Please insert a blank DVD into the Writer"
		    sleep 20
    	            $DVDMINUS_RECORDCMD dev=$DVDMINUS_DEVICE $DVDMINUS_OPTS ${Image}
    	            status=$?
    	            if [ $status -eq 0 ]
		    then
			 rm ${Image} 
		    else
			echo "$DVDRECORD Report error $status. Try again"|xargs $SVDRPSEND MESG
		        sleep 300
		    fi
	        done
    	        $SVDRPSEND MESG "Label the new DVD"
	    fi
	    ;;
	*)
	    echo "Unknown Writertype"
	    echo "Write the Image ${Image} manualy and then remove"
	    ;;
      esac
      # Cleaning
      rm -rf ${UniqueDVDDIR}
      echo $CMDLIN >> ${JOBFIL}.done
else
      echo "ERROR : ${DESTDIR} or ${TEMPDIR} are not writable. $0 exit"
fi
